/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.87 Revision 1.95
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.87 2010/02/02 18:55:00 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.95 2010/03/20 17:59:40 arfrever Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# python@gentoo.org 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: A utility eclass that should be inherited by anything that deals with Python or Python modules. 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# Some useful functions for dealing with Python. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12inherit multilib 12inherit multilib
13 13
14if ! has "${EAPI:-0}" 0 1 2 3; then 14if ! has "${EAPI:-0}" 0 1 2 3; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 15 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 16fi
17 17
18_PYTHON2_SUPPORTED_VERSIONS=(2.4 2.5 2.6 2.7) 18_CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_PYTHON3_SUPPORTED_VERSIONS=(3.0 3.1 3.2) 19_CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2)
20_JYTHON_SUPPORTED_ABIS=(2.5-jython)
20 21
21# @ECLASS-VARIABLE: PYTHON_DEPEND 22# @ECLASS-VARIABLE: PYTHON_DEPEND
22# @DESCRIPTION: 23# @DESCRIPTION:
23# Specification of dependency on dev-lang/python. 24# Specification of dependency on dev-lang/python.
24# Syntax: 25# Syntax:
27# major_version: <2|3|*> 28# major_version: <2|3|*>
28# minimal_version: <minimal_major_version.minimal_minor_version> 29# minimal_version: <minimal_major_version.minimal_minor_version>
29# maximal_version: <maximal_major_version.maximal_minor_version> 30# maximal_version: <maximal_major_version.maximal_minor_version>
30 31
31_parse_PYTHON_DEPEND() { 32_parse_PYTHON_DEPEND() {
32 local accepted_version accepted_versions=() major_version maximal_version minimal_version python_all="0" python_atoms= python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups 33 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
33 34
34 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?" 35 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
35 version_components_groups="${PYTHON_DEPEND}" 36 version_components_groups="${PYTHON_DEPEND}"
36 37
37 if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then 38 if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then
59 fi 60 fi
60 fi 61 fi
61 62
62 if [[ "${major_version}" == "2" ]]; then 63 if [[ "${major_version}" == "2" ]]; then
63 python2="1" 64 python2="1"
64 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}") 65 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}")
65 python2_minimal_version="${minimal_version}" 66 python2_minimal_version="${minimal_version}"
66 python2_maximal_version="${maximal_version}" 67 python2_maximal_version="${maximal_version}"
67 elif [[ "${major_version}" == "3" ]]; then 68 elif [[ "${major_version}" == "3" ]]; then
68 python3="1" 69 python3="1"
69 python_versions=("${_PYTHON3_SUPPORTED_VERSIONS[@]}") 70 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}")
70 python3_minimal_version="${minimal_version}" 71 python3_minimal_version="${minimal_version}"
71 python3_maximal_version="${maximal_version}" 72 python3_maximal_version="${maximal_version}"
72 else 73 else
73 python_all="1" 74 python_all="1"
74 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}" "${_PYTHON3_SUPPORTED_VERSIONS[@]}") 75 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}")
75 python_minimal_version="${minimal_version}" 76 python_minimal_version="${minimal_version}"
76 python_maximal_version="${maximal_version}" 77 python_maximal_version="${maximal_version}"
77 fi 78 fi
78 79
79 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then 80 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
86 if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then 87 if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then
87 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'" 88 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'"
88 fi 89 fi
89 done <<< "${version_components_groups}" 90 done <<< "${version_components_groups}"
90 91
92 _PYTHON_ATOMS=()
93
91 _create_accepted_versions_range() { 94 _append_accepted_versions_range() {
92 local accepted_version="0" i 95 local accepted_version="0" i
93 for ((i = "${#python_versions[@]}"; i >= 0; i--)); do 96 for ((i = "${#python_versions[@]}"; i >= 0; i--)); do
94 if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then 97 if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then
95 accepted_version="1" 98 accepted_version="1"
96 fi 99 fi
97 if [[ "${accepted_version}" == "1" ]]; then 100 if [[ "${accepted_version}" == "1" ]]; then
98 accepted_versions+=("${python_versions[${i}]}") 101 _PYTHON_ATOMS+=("=dev-lang/python-${python_versions[${i}]}*")
99 fi 102 fi
100 if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then 103 if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then
101 accepted_version="0" 104 accepted_version="0"
102 fi 105 fi
103 done 106 done
104 } 107 }
105 108
106 if [[ "${python_all}" == "1" ]]; then 109 if [[ "${python_all}" == "1" ]]; then
110 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
111 _PYTHON_ATOMS+=("dev-lang/python")
112 else
107 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}" "${_PYTHON3_SUPPORTED_VERSIONS[@]}") 113 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}")
108 python_minimal_version="${python_minimal_version:-${python_versions[0]}}" 114 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
109 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 115 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
110 _create_accepted_versions_range 116 _append_accepted_versions_range
117 fi
111 else 118 else
112 if [[ "${python3}" == "1" ]]; then 119 if [[ "${python3}" == "1" ]]; then
120 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
121 _PYTHON_ATOMS+=("=dev-lang/python-3*")
122 else
113 python_versions=("${_PYTHON3_SUPPORTED_VERSIONS[@]}") 123 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}")
114 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}" 124 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
115 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 125 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
116 _create_accepted_versions_range 126 _append_accepted_versions_range
127 fi
117 fi 128 fi
118 if [[ "${python2}" == "1" ]]; then 129 if [[ "${python2}" == "1" ]]; then
130 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
131 _PYTHON_ATOMS+=("=dev-lang/python-2*")
132 else
119 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}") 133 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}")
120 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}" 134 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
121 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 135 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
122 _create_accepted_versions_range 136 _append_accepted_versions_range
123 fi 137 fi
124 fi 138 fi
139 fi
125 140
126 for accepted_version in "${accepted_versions[@]}"; do 141 unset -f _append_accepted_versions_range
127 python_atoms+="${python_atoms:+ }=dev-lang/python-${accepted_version}*"
128 done
129 142
130 _PYTHON_ATOMS="${python_atoms// /$'\n'}" 143 if [[ "${#_PYTHON_ATOMS[@]}" -gt 1 ]]; then
131 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${python_atoms} )${USE_flag:+ )}" 144 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
132 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${python_atoms} )${USE_flag:+ )}" 145 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
146 else
147 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
148 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
149 fi
133 else 150 else
134 die "Invalid syntax of PYTHON_DEPEND" 151 die "Invalid syntax of PYTHON_DEPEND"
135 fi 152 fi
136} 153}
137 154
138DEPEND=">=app-admin/eselect-python-20090804" 155DEPEND=">=app-admin/eselect-python-20091230"
139RDEPEND="${DEPEND}" 156RDEPEND="${DEPEND}"
140 157
141if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then 158if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then
142 die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously" 159 die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously"
143elif [[ -n "${PYTHON_DEPEND}" ]]; then 160elif [[ -n "${PYTHON_DEPEND}" ]]; then
145elif [[ -n "${NEED_PYTHON}" ]]; then 162elif [[ -n "${NEED_PYTHON}" ]]; then
146 if ! has "${EAPI:-0}" 0 1 2; then 163 if ! has "${EAPI:-0}" 0 1 2; then
147 eerror "Use PYTHON_DEPEND instead of NEED_PYTHON." 164 eerror "Use PYTHON_DEPEND instead of NEED_PYTHON."
148 die "NEED_PYTHON cannot be used in this EAPI" 165 die "NEED_PYTHON cannot be used in this EAPI"
149 fi 166 fi
150 _PYTHON_ATOMS=">=dev-lang/python-${NEED_PYTHON}" 167 _PYTHON_ATOMS=(">=dev-lang/python-${NEED_PYTHON}")
151 DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS}" 168 DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS[@]}"
152 RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS}" 169 RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS[@]}"
153else 170else
154 _PYTHON_ATOMS="dev-lang/python" 171 _PYTHON_ATOMS=("dev-lang/python")
155fi 172fi
156 173
157# @ECLASS-VARIABLE: PYTHON_USE_WITH 174# @ECLASS-VARIABLE: PYTHON_USE_WITH
158# @DESCRIPTION: 175# @DESCRIPTION:
159# Set this to a space separated list of USE flags the Python slot in use must be built with. 176# Set this to a space separated list of USE flags the Python slot in use must be built with.
171# @DESCRIPTION: 188# @DESCRIPTION:
172# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags 189# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags
173# are respected. Only exported if one of those variables is set. 190# are respected. Only exported if one of those variables is set.
174if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 191if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
175 python_pkg_setup() { 192 python_pkg_setup() {
193 # Check if phase is pkg_setup().
194 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase"
195
176 python_pkg_setup_fail() { 196 python_pkg_setup_fail() {
177 eerror "${1}" 197 eerror "${1}"
178 die "${1}" 198 die "${1}"
179 } 199 }
180 200
181 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return 201 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
202 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
203 use ${PYTHON_USE_WITH_OPT#!} && return
204 else
205 use !${PYTHON_USE_WITH_OPT} && return
206 fi
207 fi
182 208
183 python_pkg_setup_check_USE_flags() { 209 python_pkg_setup_check_USE_flags() {
184 local pyatom use 210 local pyatom use
185 if [[ -n "${PYTHON_ABI}" ]]; then 211 pyatom="$(python_get_implementational_package)"
186 pyatom="dev-lang/python:${PYTHON_ABI}"
187 else
188 pyatom="dev-lang/python:$(PYTHON -A --ABI)"
189 fi
190 212
191 for use in ${PYTHON_USE_WITH}; do 213 for use in ${PYTHON_USE_WITH}; do
192 if ! has_version "${pyatom}[${use}]"; then 214 if ! has_version "${pyatom}[${use}]"; then
193 python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}" 215 python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
194 fi 216 fi
203 if [[ ${PYTHON_USE_WITH_OR} ]]; then 225 if [[ ${PYTHON_USE_WITH_OR} ]]; then
204 python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}" 226 python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
205 fi 227 fi
206 } 228 }
207 229
208 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 230 if _python_package_supporting_installation_for_multiple_python_abis; then
209 python_execute_function -q python_pkg_setup_check_USE_flags 231 python_execute_function -q python_pkg_setup_check_USE_flags
210 else 232 else
211 python_pkg_setup_check_USE_flags 233 python_pkg_setup_check_USE_flags
212 fi 234 fi
235
236 unset -f python_pkg_setup_check_USE_flags python_pkg_setup_fail
213 } 237 }
214 238
215 EXPORT_FUNCTIONS pkg_setup 239 EXPORT_FUNCTIONS pkg_setup
216 240
217 _PYTHON_USE_WITH_ATOM="" 241 _PYTHON_USE_WITH_ATOMS_ARRAY=()
218 if [[ -n "${PYTHON_USE_WITH}" ]]; then 242 if [[ -n "${PYTHON_USE_WITH}" ]]; then
219 while read _PYTHON_ATOM; do 243 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
220 _PYTHON_USE_WITH_ATOM+="${_PYTHON_USE_WITH_ATOM:+ }${_PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]" 244 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]")
221 done <<< "${_PYTHON_ATOMS}" 245 done
222 _PYTHON_USE_WITH_ATOM="|| ( ${_PYTHON_USE_WITH_ATOM} )"
223 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then 246 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
224 for _USE_flag in ${PYTHON_USE_WITH_OR}; do 247 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
225 while read _PYTHON_ATOM; do 248 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
226 _PYTHON_USE_WITH_ATOM+="${_PYTHON_USE_WITH_ATOM:+ }${_PYTHON_ATOM}[${_USE_flag}]" 249 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
227 done <<< "${_PYTHON_ATOMS}" 250 done
228 done 251 done
229 unset _USE_flag 252 unset _USE_flag
253 fi
254 if [[ "${#_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" -gt 1 ]]; then
230 _PYTHON_USE_WITH_ATOM="|| ( ${_PYTHON_USE_WITH_ATOM} )" 255 _PYTHON_USE_WITH_ATOMS="|| ( ${_PYTHON_USE_WITH_ATOMS_ARRAY[@]} )"
256 else
257 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
231 fi 258 fi
232 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then 259 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
233 _PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOM} )" 260 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
234 fi 261 fi
235 DEPEND+=" ${_PYTHON_USE_WITH_ATOM}" 262 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
236 RDEPEND+=" ${_PYTHON_USE_WITH_ATOM}" 263 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
237 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOM 264 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
238fi 265fi
239 266
240unset _PYTHON_ATOMS 267unset _PYTHON_ATOMS
241 268
242# ================================================================================================ 269# ================================================================================================
243# ======== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE VERSIONS OF PYTHON ======== 270# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
244# ================================================================================================ 271# ================================================================================================
245 272
246# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS 273# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
247# @DESCRIPTION: 274# @DESCRIPTION:
248# Set this in EAPI <= 4 to indicate that given package supports installation for 275# Set this in EAPI <= 4 to indicate that current package supports installation for
249# multiple versions of Python. 276# multiple Python ABIs.
250 277
251# @ECLASS-VARIABLE: PYTHON_DEFINE_DEFAULT_FUNCTIONS 278# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
252# @DESCRIPTION: 279# @DESCRIPTION:
253# Set this to define default functions for the following ebuild phases: 280# Set this to export phase functions for the following ebuild phases:
254# src_prepare, src_configure, src_compile, src_test, src_install. 281# src_prepare, src_configure, src_compile, src_test, src_install.
255if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_DEFINE_DEFAULT_FUNCTIONS}" ]]; then 282if ! has "${EAPI:-0}" 0 1; then
256 python_src_prepare() { 283 python_src_prepare() {
284 if ! _python_package_supporting_installation_for_multiple_python_abis; then
285 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
286 fi
287
257 python_copy_sources 288 python_copy_sources
258 } 289 }
259 290
260 for python_default_function in src_configure src_compile src_test src_install; do 291 for python_default_function in src_configure src_compile src_test src_install; do
261 eval "python_${python_default_function}() { python_execute_function -d -s; }" 292 eval "python_${python_default_function}() {
293 if ! _python_package_supporting_installation_for_multiple_python_abis; then
294 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
295 fi
296
297 python_execute_function -d -s \"\$@\"
298 }"
262 done 299 done
263 unset python_default_function 300 unset python_default_function
264 301
302 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
265 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 303 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
304 fi
266fi 305fi
267 306
268unset PYTHON_ABIS 307unset PYTHON_ABIS
269unset PYTHON_ABIS_SANITY_CHECKS
270 308
271# @FUNCTION: validate_PYTHON_ABIS 309# @FUNCTION: validate_PYTHON_ABIS
272# @DESCRIPTION: 310# @DESCRIPTION:
273# Ensure that PYTHON_ABIS variable has valid value. 311# Ensure that PYTHON_ABIS variable has valid value.
274# This function usually should not be directly called in ebuilds. 312# This function usually should not be directly called in ebuilds.
275validate_PYTHON_ABIS() { 313validate_PYTHON_ABIS() {
276 # Ensure that some functions cannot be accidentally successfully used in EAPI <= 4 without setting SUPPORT_PYTHON_ABIS variable. 314 if ! _python_package_supporting_installation_for_multiple_python_abis; then
277 if has "${EAPI:-0}" 0 1 2 3 4 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then 315 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
278 die "${FUNCNAME}() cannot be used in this EAPI without setting SUPPORT_PYTHON_ABIS variable"
279 fi 316 fi
280 317
281 # Ensure that /usr/bin/python and /usr/bin/python-config are valid. 318 _python_initial_sanity_checks
282 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
283 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
284 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
285 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
286 fi
287 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
288 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
289 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
290 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
291 fi
292 319
293 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5. 320 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5.
294 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 321 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
295 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS= 322 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS=
296 PYTHON_ABI_SUPPORTED_VALUES="${_PYTHON2_SUPPORTED_VERSIONS[@]} ${_PYTHON3_SUPPORTED_VERSIONS[@]}" 323 PYTHON_ABI_SUPPORTED_VALUES="${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]}"
297 324
298 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 325 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
299 local python2_enabled="0" python3_enabled="0" 326 local cpython_enabled="0"
300 327
301 if [[ -z "${USE_PYTHON}" ]]; then 328 if [[ -z "${USE_PYTHON}" ]]; then
302 die "USE_PYTHON variable is empty" 329 die "USE_PYTHON variable is empty"
303 fi 330 fi
304 331
305 for PYTHON_ABI in ${USE_PYTHON}; do 332 for PYTHON_ABI in ${USE_PYTHON}; do
306 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 333 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then
307 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'" 334 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
308 fi 335 fi
309 336
310 if has "${PYTHON_ABI}" "${_PYTHON2_SUPPORTED_VERSIONS[@]}"; then 337 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then
311 python2_enabled="1" 338 cpython_enabled="1"
312 fi
313 if has "${PYTHON_ABI}" "${_PYTHON3_SUPPORTED_VERSIONS[@]}"; then
314 python3_enabled="1"
315 fi 339 fi
316 340
317 support_ABI="1" 341 support_ABI="1"
318 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 342 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
319 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 343 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
323 done 347 done
324 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}" 348 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
325 done 349 done
326 350
327 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then 351 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
328 die "USE_PYTHON variable does not enable any version of Python supported by ${CATEGORY}/${PF}" 352 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
329 fi 353 fi
330 354
331 if [[ "${python2_enabled}" == "0" ]]; then 355 if [[ "${cpython_enabled}" == "0" ]]; then
332 ewarn "USE_PYTHON variable does not enable any version of Python 2. This configuration is unsupported." 356 die "USE_PYTHON variable does not enable any CPython ABI"
333 fi
334 if [[ "${python3_enabled}" == "0" ]]; then
335 ewarn "USE_PYTHON variable does not enable any version of Python 3. This configuration is unsupported."
336 fi 357 fi
337 else 358 else
338 local python_version python2_version= python3_version= support_python_major_version 359 local python_version python2_version= python3_version= support_python_major_version
339 360
340 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" 361 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
341 362
342 if has_version "=dev-lang/python-2*"; then 363 if has_version "=dev-lang/python-2*"; then
343 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then 364 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
344 die "'${EPREFIX}/usr/bin/python2' is not valid symlink" 365 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
345 fi 366 fi
346 367
347 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" 368 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
348 369
349 for PYTHON_ABI in "${_PYTHON2_SUPPORTED_VERSIONS[@]}"; do 370 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
350 support_python_major_version="1" 371 support_python_major_version="1"
351 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 372 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
352 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 373 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
353 support_python_major_version="0" 374 support_python_major_version="0"
354 fi 375 fi
369 if has_version "=dev-lang/python-3*"; then 390 if has_version "=dev-lang/python-3*"; then
370 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then 391 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then
371 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 392 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
372 fi 393 fi
373 394
374 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" 395 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
375 396
376 for PYTHON_ABI in "${_PYTHON3_SUPPORTED_VERSIONS[@]}"; do 397 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do
377 support_python_major_version="1" 398 support_python_major_version="1"
378 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 399 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
379 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 400 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
380 support_python_major_version="0" 401 support_python_major_version="0"
381 fi 402 fi
408 PYTHON_ABIS="${PYTHON_ABIS# }" 429 PYTHON_ABIS="${PYTHON_ABIS# }"
409 export PYTHON_ABIS="${PYTHON_ABIS% }" 430 export PYTHON_ABIS="${PYTHON_ABIS% }"
410 fi 431 fi
411 fi 432 fi
412 433
413 if ! _python_implementation && [[ "$(declare -p PYTHON_ABIS_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_ABIS_SANITY_CHECKS="* ]]; then 434 _python_final_sanity_checks
414 local PYTHON_ABI
415 for PYTHON_ABI in ${PYTHON_ABIS}; do
416 # Ensure that appropriate version of Python is installed.
417 if ! has_version "dev-lang/python:${PYTHON_ABI}"; then
418 die "dev-lang/python:${PYTHON_ABI} is not installed"
419 fi
420
421 # Ensure that EPYTHON variable is respected.
422 if [[ "$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" != "${PYTHON_ABI}" ]]; then
423 eerror "python: '$(type -p python)'"
424 eerror "ABI: '${ABI}'"
425 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
426 eerror "EPYTHON: '$(PYTHON)'"
427 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
428 eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')'"
429 die "'python' does not respect EPYTHON variable"
430 fi
431 done
432 PYTHON_ABIS_SANITY_CHECKS="1"
433 fi
434} 435}
435 436
436# @FUNCTION: python_execute_function 437# @FUNCTION: python_execute_function
437# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments] 438# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
438# @DESCRIPTION: 439# @DESCRIPTION:
439# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 440# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
440# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 441# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
441python_execute_function() { 442python_execute_function() {
442 local action action_message action_message_template= default_function="0" failure_message failure_message_template= function i nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir= 443 if ! _python_package_supporting_installation_for_multiple_python_abis; then
444 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
445 fi
446
447 _python_set_color_variables
448
449 local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function i iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir=
443 450
444 while (($#)); do 451 while (($#)); do
445 case "$1" in 452 case "$1" in
446 --action-message) 453 --action-message)
447 action_message_template="$2" 454 action_message_template="$2"
452 ;; 459 ;;
453 --failure-message) 460 --failure-message)
454 failure_message_template="$2" 461 failure_message_template="$2"
455 shift 462 shift
456 ;; 463 ;;
464 -f|--final-ABI)
465 final_ABI="1"
466 ;;
457 --nonfatal) 467 --nonfatal)
458 nonfatal="1" 468 nonfatal="1"
459 ;; 469 ;;
460 -q|--quiet) 470 -q|--quiet)
461 quiet="1" 471 quiet="1"
494 504
495 if [[ -z "$(type -t "${function}")" ]]; then 505 if [[ -z "$(type -t "${function}")" ]]; then
496 die "${FUNCNAME}(): '${function}' function is not defined" 506 die "${FUNCNAME}(): '${function}' function is not defined"
497 fi 507 fi
498 else 508 else
499 if [[ "$#" -ne 0 ]]; then
500 die "${FUNCNAME}(): '--default-function' option and function name cannot be specified simultaneously"
501 fi
502 if has "${EAPI:-0}" 0 1; then 509 if has "${EAPI:-0}" 0 1; then
503 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI" 510 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
504 fi 511 fi
505 512
506 if [[ "${EBUILD_PHASE}" == "configure" ]]; then 513 if [[ "${EBUILD_PHASE}" == "configure" ]]; then
507 if has "${EAPI}" 2 3; then 514 if has "${EAPI}" 2 3; then
508 python_default_function() { 515 python_default_function() {
509 econf 516 econf "$@"
510 } 517 }
511 else 518 else
512 python_default_function() { 519 python_default_function() {
513 nonfatal econf 520 nonfatal econf "$@"
514 } 521 }
515 fi 522 fi
516 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then 523 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
517 python_default_function() { 524 python_default_function() {
518 emake 525 emake "$@"
519 } 526 }
520 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 527 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
521 python_default_function() { 528 python_default_function() {
522 if emake -j1 -n check &> /dev/null; then 529 if emake -j1 -n check &> /dev/null; then
523 emake -j1 check 530 emake -j1 check "$@"
524 elif emake -j1 -n test &> /dev/null; then 531 elif emake -j1 -n test &> /dev/null; then
525 emake -j1 test 532 emake -j1 test "$@"
526 fi 533 fi
527 } 534 }
528 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 535 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
529 python_default_function() { 536 python_default_function() {
530 emake DESTDIR="${D}" install 537 emake DESTDIR="${D}" install "$@"
531 } 538 }
532 else 539 else
533 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase" 540 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
534 fi 541 fi
535 function="python_default_function" 542 function="python_default_function"
536 fi 543 fi
537 544
545 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
538 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do 546 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do
539 if [[ "${FUNCNAME[${i}]}" == "python_execute_function" ]]; then 547 if [[ "${FUNCNAME[${i}]}" == "${FUNCNAME}" ]]; then
540 die "${FUNCNAME}(): Invalid call stack" 548 die "${FUNCNAME}(): Invalid call stack"
541 fi 549 fi
542 done 550 done
543 551
544 if [[ "${quiet}" == "0" ]]; then 552 if [[ "${quiet}" == "0" ]]; then
553 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation" 561 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
554 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation" 562 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
555 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation" 563 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
556 fi 564 fi
557 565
558 local RED GREEN BLUE NORMAL 566 validate_PYTHON_ABIS
559 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then 567 if [[ "${final_ABI}" == "1" ]]; then
560 RED=$'\e[1;31m' 568 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
561 GREEN=$'\e[1;32m'
562 BLUE=$'\e[1;34m'
563 NORMAL=$'\e[0m'
564 else 569 else
565 RED= 570 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
566 GREEN=
567 BLUE=
568 NORMAL=
569 fi 571 fi
570
571 validate_PYTHON_ABIS
572 for PYTHON_ABI in ${PYTHON_ABIS}; do 572 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
573 if [[ "${quiet}" == "0" ]]; then 573 if [[ "${quiet}" == "0" ]]; then
574 if [[ -n "${action_message_template}" ]]; then 574 if [[ -n "${action_message_template}" ]]; then
575 action_message="$(eval echo -n "${action_message_template}")" 575 action_message="$(eval echo -n "${action_message_template}")"
576 else 576 else
577 action_message="${action} of ${CATEGORY}/${PF} with Python ${PYTHON_ABI}..." 577 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..."
578 fi 578 fi
579 echo " ${GREEN}*${NORMAL} ${BLUE}${action_message}${NORMAL}" 579 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
580 fi 580 fi
581 581
582 if [[ "${separate_build_dirs}" == "1" ]]; then 582 if [[ "${separate_build_dirs}" == "1" ]]; then
583 if [[ -n "${source_dir}" ]]; then 583 if [[ -n "${source_dir}" ]]; then
584 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}" 584 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}"
602 602
603 if [[ "$?" != "0" ]]; then 603 if [[ "$?" != "0" ]]; then
604 if [[ -n "${failure_message_template}" ]]; then 604 if [[ -n "${failure_message_template}" ]]; then
605 failure_message="$(eval echo -n "${failure_message_template}")" 605 failure_message="$(eval echo -n "${failure_message_template}")"
606 else 606 else
607 failure_message="${action} failed with Python ${PYTHON_ABI} in ${function}() function" 607 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function"
608 fi 608 fi
609 609
610 if [[ "${nonfatal}" == "1" ]]; then 610 if [[ "${nonfatal}" == "1" ]]; then
611 if [[ "${quiet}" == "0" ]]; then 611 if [[ "${quiet}" == "0" ]]; then
612 ewarn "${RED}${failure_message}${NORMAL}" 612 ewarn "${_RED}${failure_message}${_NORMAL}"
613 fi 613 fi
614 elif has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 614 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
615 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then 615 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
616 local enabled_PYTHON_ABIS= other_PYTHON_ABI 616 local enabled_PYTHON_ABIS= other_PYTHON_ABI
617 for other_PYTHON_ABI in ${PYTHON_ABIS}; do 617 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
618 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}" 618 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
619 done 619 done
620 export PYTHON_ABIS="${enabled_PYTHON_ABIS}" 620 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
621 fi 621 fi
622 if [[ "${quiet}" == "0" ]]; then 622 if [[ "${quiet}" == "0" ]]; then
623 ewarn "${RED}${failure_message}${NORMAL}" 623 ewarn "${_RED}${failure_message}${_NORMAL}"
624 fi 624 fi
625 if [[ -z "${PYTHON_ABIS}" ]]; then 625 if [[ -z "${PYTHON_ABIS}" ]]; then
626 die "${function}() function failed with all enabled versions of Python" 626 die "${function}() function failed with all enabled Python ABIs"
627 fi 627 fi
628 else 628 else
629 die "${failure_message}" 629 die "${failure_message}"
630 fi 630 fi
631 fi 631 fi
661 unset -f python_default_function 661 unset -f python_default_function
662 fi 662 fi
663} 663}
664 664
665# @FUNCTION: python_copy_sources 665# @FUNCTION: python_copy_sources
666# @USAGE: [--no-link] [--] [directory] 666# @USAGE: <directory="${S}"> [directory]
667# @DESCRIPTION: 667# @DESCRIPTION:
668# Copy unpacked sources of given package to separate build directory for each Python ABI. 668# Copy unpacked sources of current package to separate build directory for each Python ABI.
669python_copy_sources() { 669python_copy_sources() {
670 if ! _python_package_supporting_installation_for_multiple_python_abis; then
671 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
672 fi
673
670 local dir dirs=() no_link="0" PYTHON_ABI 674 local dir dirs=() PYTHON_ABI
671
672 while (($#)); do
673 case "$1" in
674 --no-link)
675 no_link="1"
676 ;;
677 --)
678 shift
679 break
680 ;;
681 -*)
682 die "${FUNCNAME}(): Unrecognized option '$1'"
683 ;;
684 *)
685 break
686 ;;
687 esac
688 shift
689 done
690 675
691 if [[ "$#" -eq 0 ]]; then 676 if [[ "$#" -eq 0 ]]; then
692 if [[ "${WORKDIR}" == "${S}" ]]; then 677 if [[ "${WORKDIR}" == "${S}" ]]; then
693 die "${FUNCNAME}() cannot be used" 678 die "${FUNCNAME}() cannot be used"
694 fi 679 fi
695 dirs="${S}" 680 dirs=("${S%/}")
696 else 681 else
697 dirs="$@" 682 dirs=("$@")
698 fi 683 fi
699 684
700 validate_PYTHON_ABIS 685 validate_PYTHON_ABIS
701 for PYTHON_ABI in ${PYTHON_ABIS}; do 686 for PYTHON_ABI in ${PYTHON_ABIS}; do
702 for dir in "${dirs[@]}"; do 687 for dir in "${dirs[@]}"; do
703 if [[ "${no_link}" == "1" ]]; then
704 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed" 688 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
705 else
706 cp -lpr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
707 fi
708 done 689 done
709 done 690 done
710}
711
712# @FUNCTION: python_set_build_dir_symlink
713# @USAGE: [directory="build"]
714# @DESCRIPTION:
715# Create build directory symlink.
716python_set_build_dir_symlink() {
717 local dir="$1"
718
719 [[ -z "${PYTHON_ABI}" ]] && die "PYTHON_ABI variable not set"
720 [[ -z "${dir}" ]] && dir="build"
721
722 # Do not delete preexistent directories.
723 rm -f "${dir}" || die "Deletion of '${dir}' failed"
724 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed"
725} 691}
726 692
727# @FUNCTION: python_generate_wrapper_scripts 693# @FUNCTION: python_generate_wrapper_scripts
728# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files] 694# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
729# @DESCRIPTION: 695# @DESCRIPTION:
730# Generate wrapper scripts. Existing files are overwritten only with --force option. 696# Generate wrapper scripts. Existing files are overwritten only with --force option.
731# If --respect-EPYTHON option is specified, then generated wrapper scripts will 697# If --respect-EPYTHON option is specified, then generated wrapper scripts will
732# respect EPYTHON variable at run time. 698# respect EPYTHON variable at run time.
733python_generate_wrapper_scripts() { 699python_generate_wrapper_scripts() {
700 if ! _python_package_supporting_installation_for_multiple_python_abis; then
701 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
702 fi
703
734 _python_initialize_prefix_variables 704 _python_initialize_prefix_variables
735 705
736 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0" 706 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
737 707
738 while (($#)); do 708 while (($#)); do
763 if [[ "$#" -eq 0 ]]; then 733 if [[ "$#" -eq 0 ]]; then
764 die "${FUNCNAME}(): Missing arguments" 734 die "${FUNCNAME}(): Missing arguments"
765 fi 735 fi
766 736
767 validate_PYTHON_ABIS 737 validate_PYTHON_ABIS
768 for PYTHON_ABI in "${_PYTHON2_SUPPORTED_VERSIONS[@]}"; do 738 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
769 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 739 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
770 python2_enabled="1" 740 python2_enabled="1"
771 fi 741 fi
772 done 742 done
773 for PYTHON_ABI in "${_PYTHON3_SUPPORTED_VERSIONS[@]}"; do 743 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do
774 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 744 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
775 python3_enabled="1" 745 python3_enabled="1"
776 fi 746 fi
777 done 747 done
778 748
790 if [[ -f "${file}" && "${force}" == "0" ]]; then 760 if [[ -f "${file}" && "${force}" == "0" ]]; then
791 die "${FUNCNAME}(): '$1' already exists" 761 die "${FUNCNAME}(): '$1' already exists"
792 fi 762 fi
793 763
794 if [[ "${quiet}" == "0" ]]; then 764 if [[ "${quiet}" == "0" ]]; then
795 einfo "Generating '${file#${D%/}}' wrapper script" 765 einfo "Generating '${file#${ED%/}}' wrapper script"
796 fi 766 fi
797 767
798 cat << EOF > "${file}" 768 cat << EOF > "${file}"
799#!/usr/bin/env python 769#!/usr/bin/env python
800# Gentoo '${file##*/}' wrapper script 770# Gentoo '${file##*/}' wrapper script generated by python_generate_wrapper_scripts()
801 771
802import os 772import os
803import re 773import re
804import subprocess 774import subprocess
805import sys 775import sys
806 776
807EPYTHON_re = re.compile(r"^python(\d+\.\d+)$") 777EPYTHON_re = re.compile(r"^python(\d+\.\d+)$")
778python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)")
779python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
808 780
809EOF 781EOF
810 if [[ "$?" != "0" ]]; then 782 if [[ "$?" != "0" ]]; then
811 die "${FUNCNAME}(): Generation of '$1' failed" 783 die "${FUNCNAME}(): Generation of '$1' failed"
812 fi 784 fi
827 raise ValueError 799 raise ValueError
828 except (OSError, ValueError): 800 except (OSError, ValueError):
829 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 801 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
830 sys.exit(1) 802 sys.exit(1)
831 803
832 eselect_output = eselect_process.stdout.read() 804 EPYTHON = eselect_process.stdout.read()
833 if not isinstance(eselect_output, str): 805 if not isinstance(EPYTHON, str):
834 # Python 3 806 # Python 3
835 eselect_output = eselect_output.decode() 807 EPYTHON = EPYTHON.decode()
808 EPYTHON = EPYTHON.rstrip("\n")
836 809
837 EPYTHON_matched = EPYTHON_re.match(eselect_output) 810 EPYTHON_matched = EPYTHON_re.match(EPYTHON)
838 if EPYTHON_matched: 811 if EPYTHON_matched:
839 PYTHON_ABI = EPYTHON_matched.group(1) 812 PYTHON_ABI = EPYTHON_matched.group(1)
840 else: 813 else:
841 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output) 814 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
842 sys.exit(1) 815 sys.exit(1)
843EOF 816EOF
844 if [[ "$?" != "0" ]]; then 817 if [[ "$?" != "0" ]]; then
845 die "${FUNCNAME}(): Generation of '$1' failed" 818 die "${FUNCNAME}(): Generation of '$1' failed"
846 fi 819 fi
852 raise ValueError 825 raise ValueError
853except (OSError, ValueError): 826except (OSError, ValueError):
854 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 827 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
855 sys.exit(1) 828 sys.exit(1)
856 829
857eselect_output = eselect_process.stdout.read() 830EPYTHON = eselect_process.stdout.read()
858if not isinstance(eselect_output, str): 831if not isinstance(EPYTHON, str):
859 # Python 3 832 # Python 3
860 eselect_output = eselect_output.decode() 833 EPYTHON = EPYTHON.decode()
834EPYTHON = EPYTHON.rstrip("\n")
861 835
862EPYTHON_matched = EPYTHON_re.match(eselect_output) 836EPYTHON_matched = EPYTHON_re.match(EPYTHON)
863if EPYTHON_matched: 837if EPYTHON_matched:
864 PYTHON_ABI = EPYTHON_matched.group(1) 838 PYTHON_ABI = EPYTHON_matched.group(1)
865else: 839else:
866 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output) 840 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
867 sys.exit(1) 841 sys.exit(1)
868EOF 842EOF
869 if [[ "$?" != "0" ]]; then 843 if [[ "$?" != "0" ]]; then
870 die "${FUNCNAME}(): Generation of '$1' failed" 844 die "${FUNCNAME}(): Generation of '$1' failed"
871 fi 845 fi
872 fi 846 fi
873 cat << EOF >> "${file}" 847 cat << EOF >> "${file}"
874 848
875os.environ["PYTHON_PROCESS_NAME"] = sys.argv[0] 849wrapper_script_path = os.path.realpath(sys.argv[0])
876target_executable = "%s-%s" % (os.path.realpath(sys.argv[0]), PYTHON_ABI) 850target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
851os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
852os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
877if not os.path.exists(target_executable): 853if not os.path.exists(target_executable_path):
878 sys.stderr.write("'%s' does not exist\n" % target_executable) 854 sys.stderr.write("'%s' does not exist\n" % target_executable_path)
879 sys.exit(1) 855 sys.exit(1)
880 856
857target_executable = open(target_executable_path, "rb")
858target_executable_first_line = target_executable.readline()
859if not isinstance(target_executable_first_line, str):
860 # Python 3
861 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
862
863python_shebang_matched = python_shebang_re.match(target_executable_first_line)
864target_executable.close()
865
866if python_shebang_matched:
867 try:
868 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON
869 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
870 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
871 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
872 if python_verification_process.wait() != 0:
873 raise ValueError
874
875 python_verification_output = python_verification_process.stdout.read()
876 if not isinstance(python_verification_output, str):
877 # Python 3
878 python_verification_output = python_verification_output.decode()
879
880 if not python_verification_output_re.match(python_verification_output):
881 raise ValueError
882
883 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv)
884 except:
885 pass
886 if "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION" in os.environ:
887 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
888
881os.execv(target_executable, sys.argv) 889os.execv(target_executable_path, sys.argv)
882EOF 890EOF
883 if [[ "$?" != "0" ]]; then 891 if [[ "$?" != "0" ]]; then
884 die "${FUNCNAME}(): Generation of '$1' failed" 892 die "${FUNCNAME}(): Generation of '$1' failed"
885 fi 893 fi
886 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed" 894 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
887 done 895 done
888} 896}
889 897
890# ================================================================================================ 898# ================================================================================================
891# ====== FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE VERSIONS OF PYTHON ====== 899# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
892# ================================================================================================ 900# ================================================================================================
893 901
894# @FUNCTION: python_set_active_version 902# @FUNCTION: python_set_active_version
895# @USAGE: <Python_ABI|2|3> 903# @USAGE: <CPython_ABI|2|3>
896# @DESCRIPTION: 904# @DESCRIPTION:
897# Set active version of Python. 905# Set specified version of CPython as active version of Python.
898python_set_active_version() { 906python_set_active_version() {
907 if _python_package_supporting_installation_for_multiple_python_abis; then
908 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
909 fi
910
899 if [[ "$#" -ne 1 ]]; then 911 if [[ "$#" -ne 1 ]]; then
900 die "${FUNCNAME}() requires 1 argument" 912 die "${FUNCNAME}() requires 1 argument"
901 fi 913 fi
914
915 _python_initial_sanity_checks
902 916
903 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 917 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
904 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then 918 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then
905 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed" 919 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed"
906 fi 920 fi
922 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses, 936 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
923 # so it does not need to be exported to subprocesses. 937 # so it does not need to be exported to subprocesses.
924 PYTHON_ABI="${EPYTHON#python}" 938 PYTHON_ABI="${EPYTHON#python}"
925 PYTHON_ABI="${PYTHON_ABI%%-*}" 939 PYTHON_ABI="${PYTHON_ABI%%-*}"
926 940
941 _python_final_sanity_checks
942
927 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 943 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
928 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 944 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
929} 945}
930 946
931# @FUNCTION: python_need_rebuild 947# @FUNCTION: python_need_rebuild
932# @DESCRIPTION: Run without arguments, specifies that the package should be 948# @DESCRIPTION: Mark current package for rebuilding by python-updater after
933# rebuilt after a python upgrade. 949# switching of active version of Python.
934# Do not use this function in ebuilds of packages supporting installation
935# for multiple versions of Python.
936python_need_rebuild() { 950python_need_rebuild() {
951 if _python_package_supporting_installation_for_multiple_python_abis; then
952 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
953 fi
954
937 export PYTHON_NEED_REBUILD="$(PYTHON -A --ABI)" 955 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
938} 956}
939 957
940# ================================================================================================ 958# ================================================================================================
941# ======================================= GETTER FUNCTIONS ======================================= 959# ======================================= GETTER FUNCTIONS =======================================
942# ================================================================================================ 960# ================================================================================================
943 961
962_PYTHON_ABI_EXTRACTION_COMMAND='import platform
963import sys
964sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
965if platform.system()[:4] == "Java":
966 sys.stdout.write("-jython")'
967
968_python_get_implementation() {
969 if [[ "$#" -ne 1 ]]; then
970 die "${FUNCNAME}() requires 1 argument"
971 fi
972
973 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
974 echo "CPython"
975 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
976 echo "Jython"
977 else
978 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
979 fi
980}
981
944# @FUNCTION: PYTHON 982# @FUNCTION: PYTHON
945# @USAGE: [-2] [-3] [--ABI] [-A|--active] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}"> 983# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
946# @DESCRIPTION: 984# @DESCRIPTION:
947# Print Python interpreter filename for specified Python ABI. If Python_ABI argument 985# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
948# is ommitted, then PYTHON_ABI environment variable must be set and is used. 986# is ommitted, then PYTHON_ABI environment variable must be set and is used.
949# If -2 option is specified, then active version of Python 2 is used. 987# If -2 option is specified, then active version of Python 2 is used.
950# If -3 option is specified, then active version of Python 3 is used. 988# If -3 option is specified, then active version of Python 3 is used.
951# If --active option is specified, then active version of Python is used.
952# Active version of Python can be set by python_set_active_version().
953# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 989# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
954# -2, -3, --active and --final-ABI options and Python_ABI argument cannot be specified simultaneously. 990# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
955# If --ABI option is specified, then only specified Python ABI is printed instead of 991# If --ABI option is specified, then only specified Python ABI is printed instead of
956# Python interpreter filename. 992# filename of Python interpreter.
993# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
957# --ABI and --absolute-path options cannot be specified simultaneously. 994# --ABI and --absolute-path options cannot be specified simultaneously.
958PYTHON() { 995PYTHON() {
959 local ABI_output="0" absolute_path_output="0" active="0" final_ABI="0" python2="0" python3="0" slot= 996 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
960 997
961 while (($#)); do 998 while (($#)); do
962 case "$1" in 999 case "$1" in
963 -2) 1000 -2)
964 python2="1" 1001 python2="1"
967 python3="1" 1004 python3="1"
968 ;; 1005 ;;
969 --ABI) 1006 --ABI)
970 ABI_output="1" 1007 ABI_output="1"
971 ;; 1008 ;;
972 -A|--active)
973 active="1"
974 ;;
975 -a|--absolute-path) 1009 -a|--absolute-path)
976 absolute_path_output="1" 1010 absolute_path_output="1"
977 ;; 1011 ;;
978 -f|--final-ABI) 1012 -f|--final-ABI)
979 final_ABI="1" 1013 final_ABI="1"
994 1028
995 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then 1029 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
996 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously" 1030 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously"
997 fi 1031 fi
998 1032
999 if [[ "$((${python2} + ${python3} + ${active} + ${final_ABI}))" -gt 1 ]]; then 1033 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1000 die "${FUNCNAME}(): '-2', '-3', '--active' or '--final-ABI' options cannot be specified simultaneously" 1034 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1001 fi 1035 fi
1002 1036
1003 if [[ "$#" -eq 0 ]]; then 1037 if [[ "$#" -eq 0 ]]; then
1004 if [[ "${active}" == "1" ]]; then
1005 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
1006 die "${FUNCNAME}(): '--active' option cannot be used in ebuilds of packages supporting installation for multiple versions of Python"
1007 fi
1008 slot="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
1009 elif [[ "${final_ABI}" == "1" ]]; then 1038 if [[ "${final_ABI}" == "1" ]]; then
1010 if has "${EAPI:-0}" 0 1 2 3 4 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then 1039 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1011 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple versions of Python" 1040 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1012 fi 1041 fi
1013 validate_PYTHON_ABIS 1042 validate_PYTHON_ABIS
1014 slot="${PYTHON_ABIS##* }" 1043 PYTHON_ABI="${PYTHON_ABIS##* }"
1015 elif [[ "${python2}" == "1" ]]; then 1044 elif [[ "${python2}" == "1" ]]; then
1016 slot="$(eselect python show --python2)" 1045 PYTHON_ABI="$(eselect python show --python2 --ABI)"
1017 if [[ -z "${slot}" ]]; then 1046 if [[ -z "${PYTHON_ABI}" ]]; then
1018 die "${FUNCNAME}(): Active Python 2 interpreter not set" 1047 die "${FUNCNAME}(): Active Python 2 interpreter not set"
1019 elif [[ "${slot}" != "python2."* ]]; then 1048 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1020 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1049 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1021 fi 1050 fi
1022 slot="${slot#python}"
1023 elif [[ "${python3}" == "1" ]]; then 1051 elif [[ "${python3}" == "1" ]]; then
1024 slot="$(eselect python show --python3)" 1052 PYTHON_ABI="$(eselect python show --python3 --ABI)"
1025 if [[ -z "${slot}" ]]; then 1053 if [[ -z "${PYTHON_ABI}" ]]; then
1026 die "${FUNCNAME}(): Active Python 3 interpreter not set" 1054 die "${FUNCNAME}(): Active Python 3 interpreter not set"
1027 elif [[ "${slot}" != "python3."* ]]; then 1055 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1028 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1056 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1029 fi 1057 fi
1030 slot="${slot#python}" 1058 elif ! _python_package_supporting_installation_for_multiple_python_abis; then
1059 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1031 elif [[ -n "${PYTHON_ABI}" ]]; then 1060 elif [[ -z "${PYTHON_ABI}" ]]; then
1032 slot="${PYTHON_ABI}" 1061 die "${FUNCNAME}(): Invalid usage: ${FUNCNAME}() should be used in ABI-specific local scope"
1033 else
1034 die "${FUNCNAME}(): Invalid usage"
1035 fi 1062 fi
1036 elif [[ "$#" -eq 1 ]]; then 1063 elif [[ "$#" -eq 1 ]]; then
1037 if [[ "${active}" == "1" ]]; then
1038 die "${FUNCNAME}(): '--active' option and Python ABI cannot be specified simultaneously"
1039 fi
1040 if [[ "${final_ABI}" == "1" ]]; then 1064 if [[ "${final_ABI}" == "1" ]]; then
1041 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously" 1065 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1042 fi 1066 fi
1043 if [[ "${python2}" == "1" ]]; then 1067 if [[ "${python2}" == "1" ]]; then
1044 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously" 1068 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously"
1045 fi 1069 fi
1046 if [[ "${python3}" == "1" ]]; then 1070 if [[ "${python3}" == "1" ]]; then
1047 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously" 1071 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously"
1048 fi 1072 fi
1049 slot="$1" 1073 PYTHON_ABI="$1"
1050 else 1074 else
1051 die "${FUNCNAME}(): Invalid usage" 1075 die "${FUNCNAME}(): Invalid usage"
1052 fi 1076 fi
1053 1077
1054 if [[ "${ABI_output}" == "1" ]]; then 1078 if [[ "${ABI_output}" == "1" ]]; then
1055 echo -n "${slot}" 1079 echo -n "${PYTHON_ABI}"
1056 return 1080 return
1057 elif [[ "${absolute_path_output}" == "1" ]]; then
1058 echo -n "${EPREFIX}/usr/bin/python${slot}"
1059 else 1081 else
1060 echo -n "python${slot}" 1082 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1083 python_interpreter="python${PYTHON_ABI}"
1084 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1085 python_interpreter="jython-${PYTHON_ABI%-jython}"
1086 fi
1087
1088 if [[ "${absolute_path_output}" == "1" ]]; then
1089 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1090 else
1091 echo -n "${python_interpreter}"
1092 fi
1061 fi 1093 fi
1062 1094
1063 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then 1095 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then
1064 echo -n "-${ABI}" 1096 echo -n "-${ABI}"
1065 fi 1097 fi
1066} 1098}
1067 1099
1068# @FUNCTION: python_get_includedir 1100# @FUNCTION: python_get_implementation
1069# @USAGE: [-f|--final-ABI] 1101# @USAGE: [-f|--final-ABI]
1070# @DESCRIPTION: 1102# @DESCRIPTION:
1071# Print path to Python include directory. 1103# Print name of Python implementation.
1072# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1104# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1073python_get_includedir() { 1105python_get_implementation() {
1074 local final_ABI="0" 1106 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1075 1107
1076 while (($#)); do 1108 while (($#)); do
1077 case "$1" in 1109 case "$1" in
1078 -f|--final-ABI) 1110 -f|--final-ABI)
1079 final_ABI="1" 1111 final_ABI="1"
1087 esac 1119 esac
1088 shift 1120 shift
1089 done 1121 done
1090 1122
1091 if [[ "${final_ABI}" == "1" ]]; then 1123 if [[ "${final_ABI}" == "1" ]]; then
1092 echo "/usr/include/python$(PYTHON -f --ABI)" 1124 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1125 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1126 fi
1127 PYTHON_ABI="$(PYTHON -f --ABI)"
1093 elif [[ -n "${PYTHON_ABI}" ]]; then 1128 elif [[ -z "${PYTHON_ABI}" ]]; then
1094 echo "/usr/include/python${PYTHON_ABI}" 1129 PYTHON_ABI="$(PYTHON --ABI)"
1095 else
1096 echo "/usr/include/python$(PYTHON -A --ABI)"
1097 fi 1130 fi
1098}
1099 1131
1100# @FUNCTION: python_get_libdir 1132 echo "$(_python_get_implementation "${PYTHON_ABI}")"
1133}
1134
1135# @FUNCTION: python_get_implementational_package
1101# @USAGE: [-f|--final-ABI] 1136# @USAGE: [-f|--final-ABI]
1102# @DESCRIPTION: 1137# @DESCRIPTION:
1103# Print path to Python library directory. 1138# Print category, name and slot of package providing Python implementation.
1104# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1139# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1105python_get_libdir() { 1140python_get_implementational_package() {
1106 local final_ABI="0" 1141 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1107 1142
1108 while (($#)); do 1143 while (($#)); do
1109 case "$1" in 1144 case "$1" in
1110 -f|--final-ABI) 1145 -f|--final-ABI)
1111 final_ABI="1" 1146 final_ABI="1"
1119 esac 1154 esac
1120 shift 1155 shift
1121 done 1156 done
1122 1157
1123 if [[ "${final_ABI}" == "1" ]]; then 1158 if [[ "${final_ABI}" == "1" ]]; then
1124 echo "/usr/$(get_libdir)/python$(PYTHON -f --ABI)" 1159 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1160 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1161 fi
1162 PYTHON_ABI="$(PYTHON -f --ABI)"
1125 elif [[ -n "${PYTHON_ABI}" ]]; then 1163 elif [[ -z "${PYTHON_ABI}" ]]; then
1164 PYTHON_ABI="$(PYTHON --ABI)"
1165 fi
1166
1167 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1168 echo "dev-lang/python:${PYTHON_ABI}"
1169 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1170 echo "dev-java/jython:${PYTHON_ABI%-jython}"
1171 fi
1172}
1173
1174# @FUNCTION: python_get_includedir
1175# @USAGE: [-f|--final-ABI]
1176# @DESCRIPTION:
1177# Print path to Python include directory.
1178# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1179python_get_includedir() {
1180 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1181
1182 while (($#)); do
1183 case "$1" in
1184 -f|--final-ABI)
1185 final_ABI="1"
1186 ;;
1187 -*)
1188 die "${FUNCNAME}(): Unrecognized option '$1'"
1189 ;;
1190 *)
1191 die "${FUNCNAME}(): Invalid usage"
1192 ;;
1193 esac
1194 shift
1195 done
1196
1197 if [[ "${final_ABI}" == "1" ]]; then
1198 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1199 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1200 fi
1201 PYTHON_ABI="$(PYTHON -f --ABI)"
1202 elif [[ -z "${PYTHON_ABI}" ]]; then
1203 PYTHON_ABI="$(PYTHON --ABI)"
1204 fi
1205
1206 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1207 echo "/usr/include/python${PYTHON_ABI}"
1208 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1209 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Include"
1210 fi
1211}
1212
1213# @FUNCTION: python_get_libdir
1214# @USAGE: [-f|--final-ABI]
1215# @DESCRIPTION:
1216# Print path to Python library directory.
1217# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1218python_get_libdir() {
1219 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1220
1221 while (($#)); do
1222 case "$1" in
1223 -f|--final-ABI)
1224 final_ABI="1"
1225 ;;
1226 -*)
1227 die "${FUNCNAME}(): Unrecognized option '$1'"
1228 ;;
1229 *)
1230 die "${FUNCNAME}(): Invalid usage"
1231 ;;
1232 esac
1233 shift
1234 done
1235
1236 if [[ "${final_ABI}" == "1" ]]; then
1237 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1238 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1239 fi
1240 PYTHON_ABI="$(PYTHON -f --ABI)"
1241 elif [[ -z "${PYTHON_ABI}" ]]; then
1242 PYTHON_ABI="$(PYTHON --ABI)"
1243 fi
1244
1245 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1126 echo "/usr/$(get_libdir)/python${PYTHON_ABI}" 1246 echo "/usr/$(get_libdir)/python${PYTHON_ABI}"
1127 else 1247 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1128 echo "/usr/$(get_libdir)/python$(PYTHON -A --ABI)" 1248 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Lib"
1129 fi 1249 fi
1130} 1250}
1131 1251
1132# @FUNCTION: python_get_sitedir 1252# @FUNCTION: python_get_sitedir
1133# @USAGE: [-f|--final-ABI] 1253# @USAGE: [-f|--final-ABI]
1138 local options=() 1258 local options=()
1139 1259
1140 while (($#)); do 1260 while (($#)); do
1141 case "$1" in 1261 case "$1" in
1142 -f|--final-ABI) 1262 -f|--final-ABI)
1263 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1264 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1265 fi
1143 options+=("$1") 1266 options+=("$1")
1144 ;; 1267 ;;
1145 -*) 1268 -*)
1146 die "${FUNCNAME}(): Unrecognized option '$1'" 1269 die "${FUNCNAME}(): Unrecognized option '$1'"
1147 ;; 1270 ;;
1160# @DESCRIPTION: 1283# @DESCRIPTION:
1161# Print path to Python library. 1284# Print path to Python library.
1162# If --linker-option is specified, then "-l${library}" linker option is printed. 1285# If --linker-option is specified, then "-l${library}" linker option is printed.
1163# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1286# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1164python_get_library() { 1287python_get_library() {
1165 local final_ABI="0" linker_option="0" python_version 1288 local final_ABI="0" linker_option="0" PYTHON_ABI="${PYTHON_ABI}"
1166 1289
1167 while (($#)); do 1290 while (($#)); do
1168 case "$1" in 1291 case "$1" in
1169 -f|--final-ABI) 1292 -f|--final-ABI)
1170 final_ABI="1" 1293 final_ABI="1"
1181 esac 1304 esac
1182 shift 1305 shift
1183 done 1306 done
1184 1307
1185 if [[ "${final_ABI}" == "1" ]]; then 1308 if [[ "${final_ABI}" == "1" ]]; then
1186 python_version="$(PYTHON -f --ABI)" 1309 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1310 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1311 fi
1312 PYTHON_ABI="$(PYTHON -f --ABI)"
1187 elif [[ -n "${PYTHON_ABI}" ]]; then 1313 elif [[ -z "${PYTHON_ABI}" ]]; then
1188 python_version="${PYTHON_ABI}" 1314 PYTHON_ABI="$(PYTHON --ABI)"
1189 else
1190 python_version="$(PYTHON -A --ABI)"
1191 fi 1315 fi
1192 1316
1317 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1193 if [[ "${linker_option}" == "1" ]]; then 1318 if [[ "${linker_option}" == "1" ]]; then
1194 echo "-lpython${python_version}" 1319 echo "-lpython${PYTHON_ABI}"
1195 else 1320 else
1196 echo "/usr/$(get_libdir)/libpython${python_version}$(get_libname)" 1321 echo "/usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
1322 fi
1323 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1324 die "${FUNCNAME}(): Jython does not have shared library"
1197 fi 1325 fi
1198} 1326}
1199 1327
1200# @FUNCTION: python_get_version 1328# @FUNCTION: python_get_version
1201# @USAGE: [-f|--final-ABI] [--major] [--minor] [--micro] 1329# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro]
1202# @DESCRIPTION: 1330# @DESCRIPTION:
1203# Print Python version. 1331# Print Python version.
1204# --major, --minor and --micro options cannot be specified simultaneously. 1332# --full, --major, --minor and --micro options cannot be specified simultaneously.
1205# If --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 1333# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
1206# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1334# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1207python_get_version() { 1335python_get_version() {
1208 local final_ABI="0" major="0" minor="0" micro="0" python_command 1336 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command
1209 1337
1210 while (($#)); do 1338 while (($#)); do
1211 case "$1" in 1339 case "$1" in
1212 -f|--final-ABI) 1340 -f|--final-ABI)
1213 final_ABI="1" 1341 final_ABI="1"
1214 ;; 1342 ;;
1343 --full)
1344 full="1"
1345 ;;
1215 --major) 1346 --major)
1216 major="1" 1347 major="1"
1217 ;; 1348 ;;
1218 --minor) 1349 --minor)
1219 minor="1" 1350 minor="1"
1229 ;; 1360 ;;
1230 esac 1361 esac
1231 shift 1362 shift
1232 done 1363 done
1233 1364
1234 if [[ "$((${major} + ${minor} + ${micro}))" -gt 1 ]]; then 1365 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
1235 die "${FUNCNAME}(): '--major', '--minor' or '--micro' options cannot be specified simultaneously" 1366 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
1236 fi 1367 fi
1237 1368
1369 if [[ "${full}" == "1" ]]; then
1370 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
1238 if [[ "${major}" == "1" ]]; then 1371 elif [[ "${major}" == "1" ]]; then
1239 python_command="from sys import version_info; print(version_info[0])" 1372 python_command="from sys import version_info; print(version_info[0])"
1240 elif [[ "${minor}" == "1" ]]; then 1373 elif [[ "${minor}" == "1" ]]; then
1241 python_command="from sys import version_info; print(version_info[1])" 1374 python_command="from sys import version_info; print(version_info[1])"
1242 elif [[ "${micro}" == "1" ]]; then 1375 elif [[ "${micro}" == "1" ]]; then
1243 python_command="from sys import version_info; print(version_info[2])" 1376 python_command="from sys import version_info; print(version_info[2])"
1244 else 1377 else
1378 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
1379 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1380 echo "${PYTHON_ABI}"
1381 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1382 echo "${PYTHON_ABI%-jython}"
1383 fi
1384 return
1385 fi
1245 python_command="from sys import version_info; print('.'.join([str(x) for x in version_info[:2]]))" 1386 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
1246 fi 1387 fi
1247 1388
1248 if [[ "${final_ABI}" == "1" ]]; then 1389 if [[ "${final_ABI}" == "1" ]]; then
1390 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1391 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1392 fi
1249 "$(PYTHON -f)" -c "${python_command}" 1393 "$(PYTHON -f)" -c "${python_command}"
1250 else 1394 else
1251 "$(PYTHON "${PYTHON_ABI--A}")" -c "${python_command}" 1395 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
1252 fi 1396 fi
1253} 1397}
1254 1398
1255# ================================================================================================ 1399# ================================================================================================
1256# =================================== MISCELLANEOUS FUNCTIONS ==================================== 1400# =================================== MISCELLANEOUS FUNCTIONS ====================================
1257# ================================================================================================ 1401# ================================================================================================
1258 1402
1259_python_implementation() { 1403_python_implementation() {
1260 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then 1404 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
1261 return 0 1405 return 0
1406 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
1407 return 0
1262 else 1408 else
1263 return 1 1409 return 1
1410 fi
1411}
1412
1413_python_package_supporting_installation_for_multiple_python_abis() {
1414 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
1415 die "${FUNCNAME}() cannot be used in global scope"
1416 fi
1417
1418 if has "${EAPI:-0}" 0 1 2 3 4; then
1419 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
1420 return 0
1421 else
1422 return 1
1423 fi
1424 else
1425 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
1264 fi 1426 fi
1265} 1427}
1266 1428
1267_python_initialize_prefix_variables() { 1429_python_initialize_prefix_variables() {
1268 if has "${EAPI:-0}" 0 1 2; then 1430 if has "${EAPI:-0}" 0 1 2; then
1270 EROOT="${ROOT%/}${EPREFIX}/" 1432 EROOT="${ROOT%/}${EPREFIX}/"
1271 fi 1433 fi
1272 if [[ -n "${D}" && -z "${ED}" ]]; then 1434 if [[ -n "${D}" && -z "${ED}" ]]; then
1273 ED="${D%/}${EPREFIX}/" 1435 ED="${D%/}${EPREFIX}/"
1274 fi 1436 fi
1437 fi
1438}
1439
1440unset PYTHON_SANITY_CHECKS
1441
1442_python_initial_sanity_checks() {
1443 if [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1444 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
1445 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
1446 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
1447 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1448 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
1449 fi
1450 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
1451 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
1452 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1453 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
1454 fi
1455 fi
1456}
1457
1458_python_final_sanity_checks() {
1459 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1460 local PYTHON_ABI="${PYTHON_ABI}"
1461 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
1462 # Ensure that appropriate version of Python is installed.
1463 if ! has_version "$(python_get_implementational_package)"; then
1464 die "$(python_get_implementational_package) is not installed"
1465 fi
1466
1467 # Ensure that EPYTHON variable is respected.
1468 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
1469 eerror "python: '$(type -p python)'"
1470 eerror "ABI: '${ABI}'"
1471 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
1472 eerror "EPYTHON: '$(PYTHON)'"
1473 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
1474 eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
1475 die "'python' does not respect EPYTHON variable"
1476 fi
1477 done
1478 fi
1479 PYTHON_SANITY_CHECKS="1"
1480}
1481
1482_python_set_color_variables() {
1483 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1484 _BOLD=$'\e[1m'
1485 _RED=$'\e[1;31m'
1486 _GREEN=$'\e[1;32m'
1487 _BLUE=$'\e[1;34m'
1488 _CYAN=$'\e[1;36m'
1489 _NORMAL=$'\e[0m'
1490 else
1491 _BOLD=
1492 _RED=
1493 _GREEN=
1494 _BLUE=
1495 _CYAN=
1496 _NORMAL=
1275 fi 1497 fi
1276} 1498}
1277 1499
1278# @FUNCTION: python_convert_shebangs 1500# @FUNCTION: python_convert_shebangs
1279# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories] 1501# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
1321 die "${FUNCNAME}(): '${argument}' does not exist" 1543 die "${FUNCNAME}(): '${argument}' does not exist"
1322 elif [[ -f "${argument}" ]]; then 1544 elif [[ -f "${argument}" ]]; then
1323 files+=("${argument}") 1545 files+=("${argument}")
1324 elif [[ -d "${argument}" ]]; then 1546 elif [[ -d "${argument}" ]]; then
1325 if [[ "${recursive}" == "1" ]]; then 1547 if [[ "${recursive}" == "1" ]]; then
1326 if [[ "${only_executables}" == "1" ]]; then 1548 while read -d $'\0' -r file; do
1327 files+=($(find "${argument}" -perm /111 -type f)) 1549 files+=("${file}")
1328 else 1550 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
1329 files+=($(find "${argument}" -type f))
1330 fi
1331 else 1551 else
1332 die "${FUNCNAME}(): '${argument}' is not a regular file" 1552 die "${FUNCNAME}(): '${argument}' is not a regular file"
1333 fi 1553 fi
1334 else 1554 else
1335 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory" 1555 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
1339 for file in "${files[@]}"; do 1559 for file in "${files[@]}"; do
1340 file="${file#./}" 1560 file="${file#./}"
1341 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 1561 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
1342 1562
1343 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then 1563 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
1564 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
1565
1344 if [[ "${quiet}" == "0" ]]; then 1566 if [[ "${quiet}" == "0" ]]; then
1345 einfo "Converting shebang in '${file}'" 1567 einfo "Converting shebang in '${file}'"
1346 fi 1568 fi
1569
1347 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed" 1570 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed"
1348 1571
1349 # Delete potential whitespace after "#!". 1572 # Delete potential whitespace after "#!".
1350 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed" 1573 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
1351 fi 1574 fi
1352 done 1575 done
1353} 1576}
1354 1577
1355# @FUNCTION: python_mod_exists 1578# @FUNCTION: python_clean_sitedirs
1356# @USAGE: <module>
1357# @DESCRIPTION: 1579# @DESCRIPTION:
1358# Run with the module name as an argument. It will check if a 1580# Delete needless files in site-packages directories in ${ED}.
1359# Python module is installed and loadable. It will return 1581python_clean_sitedirs() {
1360# TRUE(0) if the module exists, and FALSE(1) if the module does 1582 _python_initialize_prefix_variables
1361# not exist.
1362#
1363# Example:
1364# if python_mod_exists gtk; then
1365# echo "gtk support enabled"
1366# fi
1367python_mod_exists() {
1368 if [[ "$#" -ne 1 ]]; then
1369 die "${FUNCNAME}() requires 1 argument"
1370 fi
1371 "$(PYTHON "${PYTHON_ABI--A}")" -c "import $1" &> /dev/null
1372}
1373 1583
1374# @FUNCTION: python_tkinter_exists 1584 find "${ED}"usr/$(get_libdir)/python*/site-packages "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
1375# @DESCRIPTION:
1376# Run without arguments, checks if Python was compiled with Tkinter
1377# support. If not, prints an error message and dies.
1378python_tkinter_exists() {
1379 if ! "$(PYTHON "${PYTHON_ABI--A}")" -c "from sys import version_info
1380if version_info[0] == 3:
1381 import tkinter
1382else:
1383 import Tkinter" &> /dev/null; then
1384 eerror "Python needs to be rebuilt with tkinter support enabled."
1385 eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
1386 eerror "dev-lang/python tk"
1387 die "Python installed without support for tkinter"
1388 fi
1389} 1585}
1390 1586
1391# ================================================================================================ 1587# ================================================================================================
1392# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 1588# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
1393# ================================================================================================ 1589# ================================================================================================
1396# @DESCRIPTION: 1592# @DESCRIPTION:
1397# User-configurable verbosity of tests of Python modules. 1593# User-configurable verbosity of tests of Python modules.
1398# Supported values: 0, 1, 2, 3, 4. 1594# Supported values: 0, 1, 2, 3, 4.
1399PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}" 1595PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}"
1400 1596
1597_python_test_hook() {
1598 if [[ "$#" -ne 1 ]]; then
1599 die "${FUNCNAME}() requires 1 argument"
1600 fi
1601
1602 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then
1603 "${FUNCNAME[3]}_$1_hook"
1604 fi
1605}
1606
1401# @FUNCTION: python_execute_nosetests 1607# @FUNCTION: python_execute_nosetests
1402# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 1608# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1403# @DESCRIPTION: 1609# @DESCRIPTION:
1404# Execute nosetests for all enabled versions of Python. 1610# Execute nosetests for all enabled Python ABIs.
1611# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1612# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
1405python_execute_nosetests() { 1613python_execute_nosetests() {
1614 _python_set_color_variables
1615
1406 local PYTHONPATH_template= separate_build_dirs= 1616 local PYTHONPATH_template= separate_build_dirs=
1407 1617
1408 while (($#)); do 1618 while (($#)); do
1409 case "$1" in 1619 case "$1" in
1410 -P|--PYTHONPATH) 1620 -P|--PYTHONPATH)
1436 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then 1646 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1437 unset evaluated_PYTHONPATH 1647 unset evaluated_PYTHONPATH
1438 fi 1648 fi
1439 fi 1649 fi
1440 1650
1651 _python_test_hook pre
1652
1441 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 1653 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1442 echo PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 1654 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1443 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 1655 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1444 else 1656 else
1445 echo nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 1657 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1446 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 1658 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1447 fi 1659 fi
1660
1661 _python_test_hook post
1448 } 1662 }
1449 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1663 if _python_package_supporting_installation_for_multiple_python_abis; then
1450 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 1664 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1451 else 1665 else
1452 if [[ -n "${separate_build_dirs}" ]]; then 1666 if [[ -n "${separate_build_dirs}" ]]; then
1453 die "${FUNCNAME}(): Invalid usage" 1667 die "${FUNCNAME}(): Invalid usage"
1454 fi 1668 fi
1455 python_test_function "$@" 1669 python_test_function "$@" || die "Testing failed"
1456 fi 1670 fi
1671
1672 unset -f python_test_function
1457} 1673}
1458 1674
1459# @FUNCTION: python_execute_py.test 1675# @FUNCTION: python_execute_py.test
1460# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 1676# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1461# @DESCRIPTION: 1677# @DESCRIPTION:
1462# Execute py.test for all enabled versions of Python. 1678# Execute py.test for all enabled Python ABIs.
1679# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1680# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
1463python_execute_py.test() { 1681python_execute_py.test() {
1682 _python_set_color_variables
1683
1464 local PYTHONPATH_template= separate_build_dirs= 1684 local PYTHONPATH_template= separate_build_dirs=
1465 1685
1466 while (($#)); do 1686 while (($#)); do
1467 case "$1" in 1687 case "$1" in
1468 -P|--PYTHONPATH) 1688 -P|--PYTHONPATH)
1494 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then 1714 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1495 unset evaluated_PYTHONPATH 1715 unset evaluated_PYTHONPATH
1496 fi 1716 fi
1497 fi 1717 fi
1498 1718
1719 _python_test_hook pre
1720
1499 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 1721 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1500 echo PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" 1722 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
1501 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" 1723 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
1502 else 1724 else
1503 echo py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" 1725 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
1504 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" 1726 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
1505 fi 1727 fi
1728
1729 _python_test_hook post
1506 } 1730 }
1507 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1731 if _python_package_supporting_installation_for_multiple_python_abis; then
1508 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 1732 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1509 else 1733 else
1510 if [[ -n "${separate_build_dirs}" ]]; then 1734 if [[ -n "${separate_build_dirs}" ]]; then
1511 die "${FUNCNAME}(): Invalid usage" 1735 die "${FUNCNAME}(): Invalid usage"
1512 fi 1736 fi
1513 python_test_function "$@" 1737 python_test_function "$@" || die "Testing failed"
1514 fi 1738 fi
1739
1740 unset -f python_test_function
1515} 1741}
1516 1742
1517# @FUNCTION: python_execute_trial 1743# @FUNCTION: python_execute_trial
1518# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 1744# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1519# @DESCRIPTION: 1745# @DESCRIPTION:
1520# Execute trial for all enabled versions of Python. 1746# Execute trial for all enabled Python ABIs.
1747# In ebuilds of packages supporting installation for multiple Python ABIs, this function
1748# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
1521python_execute_trial() { 1749python_execute_trial() {
1750 _python_set_color_variables
1751
1522 local PYTHONPATH_template= separate_build_dirs= 1752 local PYTHONPATH_template= separate_build_dirs=
1523 1753
1524 while (($#)); do 1754 while (($#)); do
1525 case "$1" in 1755 case "$1" in
1526 -P|--PYTHONPATH) 1756 -P|--PYTHONPATH)
1552 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then 1782 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1553 unset evaluated_PYTHONPATH 1783 unset evaluated_PYTHONPATH
1554 fi 1784 fi
1555 fi 1785 fi
1556 1786
1787 _python_test_hook pre
1788
1557 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 1789 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1558 echo PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 1790 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1559 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 1791 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1560 else 1792 else
1561 echo trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 1793 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1562 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 1794 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1563 fi 1795 fi
1796
1797 _python_test_hook post
1564 } 1798 }
1565 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1799 if _python_package_supporting_installation_for_multiple_python_abis; then
1566 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 1800 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1567 else 1801 else
1568 if [[ -n "${separate_build_dirs}" ]]; then 1802 if [[ -n "${separate_build_dirs}" ]]; then
1569 die "${FUNCNAME}(): Invalid usage" 1803 die "${FUNCNAME}(): Invalid usage"
1570 fi 1804 fi
1571 python_test_function "$@" 1805 python_test_function "$@" || die "Testing failed"
1572 fi 1806 fi
1807
1808 unset -f python_test_function
1573} 1809}
1574 1810
1575# ================================================================================================ 1811# ================================================================================================
1576# ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ======================== 1812# ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ========================
1577# ================================================================================================ 1813# ================================================================================================
1599# If no arguments supplied, it will recompile not recursively all modules 1835# If no arguments supplied, it will recompile not recursively all modules
1600# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages). 1836# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
1601# 1837#
1602# If supplied with arguments, it will recompile all modules recursively 1838# If supplied with arguments, it will recompile all modules recursively
1603# in the supplied directory. 1839# in the supplied directory.
1604# This function should only be run in pkg_postinst().
1605# 1840#
1606# Options passed to this function are passed to compileall.py. 1841# Options passed to this function are passed to compileall.py.
1607# 1842#
1608# Example: 1843# This function can be used only in pkg_postinst() phase.
1609# python_mod_optimize ctypesgencore
1610python_mod_optimize() { 1844python_mod_optimize() {
1611 _python_initialize_prefix_variables 1845 _python_initialize_prefix_variables
1612 1846
1613 # Check if phase is pkg_postinst(). 1847 # Check if phase is pkg_postinst().
1614 [[ ${EBUILD_PHASE} != "postinst" ]] && die "${FUNCNAME}() should only be run in pkg_postinst()" 1848 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
1615 1849
1616 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1850 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
1617 local dir file options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" PYTHON_ABI return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 1851 local dir file options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=()
1618 1852
1619 # Strip trailing slash from ROOT. 1853 # Strip trailing slash from ROOT.
1620 root="${EROOT%/}" 1854 root="${EROOT%/}"
1621 1855
1622 # Respect ROOT and options passed to compileall.py. 1856 # Respect ROOT and options passed to compileall.py.
1644 ewarn "'${root}/$1' is not a file or a directory!" 1878 ewarn "'${root}/$1' is not a file or a directory!"
1645 else 1879 else
1646 ewarn "'${root}/$1' does not exist!" 1880 ewarn "'${root}/$1' does not exist!"
1647 fi 1881 fi
1648 else 1882 else
1649 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do 1883 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1650 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then 1884 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
1651 site_packages_dirs+=("$1") 1885 site_packages_dirs+=("$1")
1652 break 1886 break
1653 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then 1887 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
1654 site_packages_files+=("$1") 1888 site_packages_files+=("$1")
1666 done 1900 done
1667 1901
1668 # Set additional options. 1902 # Set additional options.
1669 options+=("-q") 1903 options+=("-q")
1670 1904
1671 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do 1905 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1672 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 1906 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then
1673 return_code="0" 1907 return_code="0"
1674 ebegin "Compilation and optimization of Python modules for Python ${PYTHON_ABI}" 1908 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1675 if ((${#site_packages_dirs[@]})); then 1909 if ((${#site_packages_dirs[@]})); then
1676 for dir in "${site_packages_dirs[@]}"; do 1910 for dir in "${site_packages_dirs[@]}"; do
1677 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 1911 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}")
1678 done 1912 done
1679 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 1913 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1"
1914 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1680 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 1915 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1"
1916 fi
1681 fi 1917 fi
1682 if ((${#site_packages_files[@]})); then 1918 if ((${#site_packages_files[@]})); then
1683 for file in "${site_packages_files[@]}"; do 1919 for file in "${site_packages_files[@]}"; do
1684 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 1920 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}")
1685 done 1921 done
1686 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 1922 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1"
1923 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1687 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 1924 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1"
1925 fi
1688 fi 1926 fi
1689 eend "${return_code}" 1927 eend "${return_code}"
1690 fi 1928 fi
1691 unset site_packages_absolute_dirs site_packages_absolute_files 1929 unset site_packages_absolute_dirs site_packages_absolute_files
1692 done 1930 done
1698 unset PYTHON_ABI 1936 unset PYTHON_ABI
1699 fi 1937 fi
1700 1938
1701 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 1939 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
1702 return_code="0" 1940 return_code="0"
1703 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for Python $(PYTHON -A --ABI)" 1941 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)"
1704 if ((${#other_dirs[@]})); then 1942 if ((${#other_dirs[@]})); then
1705 "$(PYTHON "${PYTHON_ABI--A}")" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 1943 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1"
1944 if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then
1706 "$(PYTHON "${PYTHON_ABI--A}")" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 1945 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
1946 fi
1707 fi 1947 fi
1708 if ((${#other_files[@]})); then 1948 if ((${#other_files[@]})); then
1709 "$(PYTHON "${PYTHON_ABI--A}")" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 1949 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1"
1950 if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then
1710 "$(PYTHON "${PYTHON_ABI--A}")" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 1951 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
1952 fi
1711 fi 1953 fi
1712 eend "${return_code}" 1954 eend "${return_code}"
1713 fi 1955 fi
1714 else 1956 else
1715 local myroot mydirs=() myfiles=() myopts=() return_code="0" 1957 local myroot mydirs=() myfiles=() myopts=() return_code="0"
1747 done 1989 done
1748 1990
1749 # set additional opts 1991 # set additional opts
1750 myopts+=(-q) 1992 myopts+=(-q)
1751 1993
1752 ebegin "Compilation and optimization of Python modules for Python $(PYTHON -A --ABI)" 1994 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1753 if ((${#mydirs[@]})); then 1995 if ((${#mydirs[@]})); then
1754 "$(PYTHON "${PYTHON_ABI--A}")" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1" 1996 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
1755 "$(PYTHON "${PYTHON_ABI--A}")" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1" 1997 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
1756 fi 1998 fi
1757 1999
1758 if ((${#myfiles[@]})); then 2000 if ((${#myfiles[@]})); then
1759 python_mod_compile "${myfiles[@]}" 2001 python_mod_compile "${myfiles[@]}"
1760 fi 2002 fi
1771# 2013#
1772# It will recursively scan all compiled Python modules in the directories and 2014# It will recursively scan all compiled Python modules in the directories and
1773# determine if they are orphaned (i.e. their corresponding .py files are missing.) 2015# determine if they are orphaned (i.e. their corresponding .py files are missing.)
1774# If they are, then it will remove their corresponding .pyc and .pyo files. 2016# If they are, then it will remove their corresponding .pyc and .pyo files.
1775# 2017#
1776# This function should only be run in pkg_postrm(). 2018# This function can be used only in pkg_postrm() phase.
1777python_mod_cleanup() { 2019python_mod_cleanup() {
1778 _python_initialize_prefix_variables 2020 _python_initialize_prefix_variables
2021 _python_set_color_variables
1779 2022
1780 local path py_file PYTHON_ABI SEARCH_PATH=() root 2023 local path py_file PYTHON_ABI="${PYTHON_ABI}" SEARCH_PATH=() root
1781 2024
1782 # Check if phase is pkg_postrm(). 2025 # Check if phase is pkg_postrm().
1783 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME}() should only be run in pkg_postrm()" 2026 [[ "${EBUILD_PHASE}" != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase"
1784 2027
1785 # Strip trailing slash from ROOT. 2028 # Strip trailing slash from ROOT.
1786 root="${EROOT%/}" 2029 root="${EROOT%/}"
1787 2030
1788 if (($#)); then 2031 if (($#)); then
1789 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2032 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
1790 while (($#)); do 2033 while (($#)); do
1791 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 2034 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1792 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories" 2035 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories"
1793 elif [[ "$1" =~ ^/ ]]; then 2036 elif [[ "$1" =~ ^/ ]]; then
1794 SEARCH_PATH+=("${root}/${1#/}") 2037 SEARCH_PATH+=("${root}/${1#/}")
1795 else 2038 else
1796 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do 2039 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1797 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1") 2040 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1")
1798 done 2041 done
1799 fi 2042 fi
1800 shift 2043 shift
1801 done 2044 done
1812 SEARCH_PATH+=("${sitedir}") 2055 SEARCH_PATH+=("${sitedir}")
1813 fi 2056 fi
1814 done 2057 done
1815 fi 2058 fi
1816 done 2059 done
2060 for sitedir in "${root}"/usr/share/jython-*/Lib/site-packages; do
2061 if [[ -d "${sitedir}" ]]; then
2062 SEARCH_PATH+=("${sitedir}")
1817 fi 2063 fi
1818 2064 done
1819 local BLUE CYAN NORMAL
1820 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1821 BLUE=$'\e[1;34m'
1822 CYAN=$'\e[1;36m'
1823 NORMAL=$'\e[0m'
1824 else
1825 BLUE=
1826 CYAN=
1827 NORMAL=
1828 fi 2065 fi
1829 2066
1830 for path in "${SEARCH_PATH[@]}"; do 2067 for path in "${SEARCH_PATH[@]}"; do
1831 if [[ -d "${path}" ]]; then 2068 if [[ -d "${path}" ]]; then
1832 find "${path}" -name '*.py[co]' -print0 | while read -rd ''; do 2069 find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0 | while read -rd ''; do
2070 if [[ "${REPLY}" == *[co] ]]; then
1833 py_file="${REPLY%[co]}" 2071 py_file="${REPLY%[co]}"
1834 [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue 2072 [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue
1835 einfo "${BLUE}<<< ${py_file}[co]${NORMAL}" 2073 echo "${_BLUE}<<< ${py_file}[co]${_NORMAL}"
1836 rm -f "${py_file}"[co] 2074 rm -f "${py_file}"[co]
2075 elif [[ "${REPLY}" == *\$py.class ]]; then
2076 py_file="${REPLY%\$py.class}.py"
2077 [[ -f "${py_file}" || ! -f "${py_file%.py}\$py.class" ]] && continue
2078 echo "${_BLUE}<<< ${py_file%.py}\$py.class${_NORMAL}"
2079 rm -f "${py_file%.py}\$py.class"
2080 fi
1837 done 2081 done
1838 2082
1839 # Attempt to delete directories, which may be empty. 2083 # Attempt to delete directories, which may be empty.
1840 find "${path}" -type d | sort -r | while read -r dir; do 2084 find "${path}" -type d | sort -r | while read -r dir; do
1841 rmdir "${dir}" 2>/dev/null && einfo "${CYAN}<<< ${dir}${NORMAL}" 2085 rmdir "${dir}" 2>/dev/null && echo "${_CYAN}<<< ${dir}${_NORMAL}"
1842 done 2086 done
1843 elif [[ "${path}" == *.py && ! -f "${path}" && (-f "${path}c" || -f "${path}o") ]]; then 2087 elif [[ "${path}" == *.py && ! -f "${path}" ]]; then
2088 if [[ (-f "${path}c" || -f "${path}o") ]]; then
1844 einfo "${BLUE}<<< ${path}[co]${NORMAL}" 2089 echo "${_BLUE}<<< ${path}[co]${_NORMAL}"
1845 rm -f "${path}"[co] 2090 rm -f "${path}"[co]
2091 fi
2092 if [[ -f "${path%.py}\$py.class" ]]; then
2093 echo "${_BLUE}<<< ${path%.py}\$py.class${_NORMAL}"
2094 rm -f "${path%.py}\$py.class"
2095 fi
1846 fi 2096 fi
1847 done 2097 done
1848} 2098}
1849 2099
1850# ================================================================================================ 2100# ================================================================================================
1854# @FUNCTION: python_version 2104# @FUNCTION: python_version
1855# @DESCRIPTION: 2105# @DESCRIPTION:
1856# Run without arguments and it will export the version of python 2106# Run without arguments and it will export the version of python
1857# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR 2107# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
1858python_version() { 2108python_version() {
1859 if ! has "${EAPI:-0}" 0 1 2; then 2109 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
1860 eerror "Use PYTHON() and/or python_get_*() instead of python_version()." 2110 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
1861 die "${FUNCNAME}() cannot be used in this EAPI" 2111 die "${FUNCNAME}() cannot be used in this EAPI"
2112 fi
2113
2114 _python_set_color_variables
2115
2116 if [[ "${FUNCNAME[1]}" != "distutils_python_version" ]]; then
2117 echo
2118 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2119 echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables.${_NORMAL}"
2120 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2121 echo
2122
2123 einfo &> /dev/null
2124 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2125 einfo "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables." &> /dev/null
2126 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2127 einfo &> /dev/null
1862 fi 2128 fi
1863 2129
1864 [[ -n "${PYVER}" ]] && return 0 2130 [[ -n "${PYVER}" ]] && return 0
1865 local tmpstr 2131 local tmpstr
1866 python="${python:-${EPREFIX}/usr/bin/python}" 2132 python="${python:-${EPREFIX}/usr/bin/python}"
1872 export PYVER_MICRO="${PYVER_ALL:4}" 2138 export PYVER_MICRO="${PYVER_ALL:4}"
1873 fi 2139 fi
1874 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}" 2140 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
1875} 2141}
1876 2142
2143# @FUNCTION: python_mod_exists
2144# @USAGE: <module>
2145# @DESCRIPTION:
2146# Run with the module name as an argument. It will check if a
2147# Python module is installed and loadable. It will return
2148# TRUE(0) if the module exists, and FALSE(1) if the module does
2149# not exist.
2150#
2151# Example:
2152# if python_mod_exists gtk; then
2153# echo "gtk support enabled"
2154# fi
2155python_mod_exists() {
2156 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2157 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2158 die "${FUNCNAME}() cannot be used in this EAPI"
2159 fi
2160
2161 echo
2162 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2163 echo " ${_RED}*${_NORMAL} ${_RED}Use USE dependencies and/or has_version() instead of ${FUNCNAME}().${_NORMAL}"
2164 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2165 echo
2166
2167 einfo &> /dev/null
2168 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2169 einfo "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()." &> /dev/null
2170 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2171 einfo &> /dev/null
2172
2173 if [[ "$#" -ne 1 ]]; then
2174 die "${FUNCNAME}() requires 1 argument"
2175 fi
2176 "$(PYTHON ${PYTHON_ABI})" -c "import $1" &> /dev/null
2177}
2178
2179# @FUNCTION: python_tkinter_exists
2180# @DESCRIPTION:
2181# Run without arguments, checks if Python was compiled with Tkinter
2182# support. If not, prints an error message and dies.
2183python_tkinter_exists() {
2184 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2185 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2186 die "${FUNCNAME}() cannot be used in this EAPI"
2187 fi
2188
2189 if [[ "${FUNCNAME[1]}" != "distutils_python_tkinter" ]]; then
2190 echo
2191 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2192 echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}().${_NORMAL}"
2193 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2194 echo
2195
2196 einfo &> /dev/null
2197 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2198 einfo "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()." &> /dev/null
2199 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2200 einfo &> /dev/null
2201 fi
2202
2203 if ! "$(PYTHON ${PYTHON_ABI})" -c "from sys import version_info
2204if version_info[0] == 3:
2205 import tkinter
2206else:
2207 import Tkinter" &> /dev/null; then
2208 eerror "Python needs to be rebuilt with tkinter support enabled."
2209 eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
2210 eerror "dev-lang/python tk"
2211 die "Python installed without support for tkinter"
2212 fi
2213}
2214
1877# @FUNCTION: python_mod_compile 2215# @FUNCTION: python_mod_compile
1878# @USAGE: <file> [more files ...] 2216# @USAGE: <file> [more files ...]
1879# @DESCRIPTION: 2217# @DESCRIPTION:
1880# Given filenames, it will pre-compile the module's .pyc and .pyo. 2218# Given filenames, it will pre-compile the module's .pyc and .pyo.
1881# This function should only be run in pkg_postinst() 2219# This function can be used only in pkg_postinst() phase.
1882# 2220#
1883# Example: 2221# Example:
1884# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py 2222# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
1885# 2223#
1886python_mod_compile() { 2224python_mod_compile() {
1887 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2225 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
1888 eerror "Use python_mod_optimize() instead of python_mod_compile()." 2226 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()."
1889 die "${FUNCNAME}() cannot be used in this EAPI" 2227 die "${FUNCNAME}() cannot be used in this EAPI"
1890 fi 2228 fi
1891 2229
1892 _python_initialize_prefix_variables 2230 _python_initialize_prefix_variables
1893 2231
1894 local f myroot myfiles=() 2232 local f myroot myfiles=()
1895 2233
1896 # Check if phase is pkg_postinst() 2234 # Check if phase is pkg_postinst()
1897 [[ ${EBUILD_PHASE} != postinst ]] && die "${FUNCNAME}() should only be run in pkg_postinst()" 2235 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
1898 2236
1899 # strip trailing slash 2237 # strip trailing slash
1900 myroot="${EROOT%/}" 2238 myroot="${EROOT%/}"
1901 2239
1902 # respect ROOT 2240 # respect ROOT
1903 for f in "$@"; do 2241 for f in "$@"; do
1904 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}") 2242 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
1905 done 2243 done
1906 2244
1907 if ((${#myfiles[@]})); then 2245 if ((${#myfiles[@]})); then
1908 "$(PYTHON "${PYTHON_ABI--A}")" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" 2246 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
1909 "$(PYTHON "${PYTHON_ABI--A}")" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null 2247 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
1910 else 2248 else
1911 ewarn "No files to compile!" 2249 ewarn "No files to compile!"
1912 fi 2250 fi
1913} 2251}

Legend:
Removed from v.1.87  
changed lines
  Added in v.1.95

  ViewVC Help
Powered by ViewVC 1.1.20